"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};

// src/index.ts
var src_exports = {};
__export(src_exports, {
  digest: () => digest,
  generateSalt: () => generateSalt,
  getHasher: () => getHasher
});
module.exports = __toCommonJS(src_exports);

// src/crypto.ts
var generateSalt = (length) => {
  if (length <= 0) {
    return "";
  }
  const array = new Uint8Array(length / 2);
  window.crypto.getRandomValues(array);
  const salt = Array.from(
    array,
    (byte) => byte.toString(16).padStart(2, "0")
  ).join("");
  return salt;
};
function digest(data, algorithm = "SHA-256") {
  return __async(this, null, function* () {
    const ec = new TextEncoder();
    const digest2 = yield window.crypto.subtle.digest(algorithm, ec.encode(data));
    return new Uint8Array(digest2);
  });
}
var getHasher = (algorithm = "SHA-256") => {
  return (data) => digest(data, algorithm);
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  digest,
  generateSalt,
  getHasher
});
