var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};

// src/crypto.ts
var generateSalt = (length) => {
  if (length <= 0) {
    return "";
  }
  const array = new Uint8Array(length / 2);
  window.crypto.getRandomValues(array);
  const salt = Array.from(
    array,
    (byte) => byte.toString(16).padStart(2, "0")
  ).join("");
  return salt;
};
function digest(data, algorithm = "SHA-256") {
  return __async(this, null, function* () {
    const ec = new TextEncoder();
    const digest2 = yield window.crypto.subtle.digest(algorithm, ec.encode(data));
    return new Uint8Array(digest2);
  });
}
var getHasher = (algorithm = "SHA-256") => {
  return (data) => digest(data, algorithm);
};
export {
  digest,
  generateSalt,
  getHasher
};
